"""
Module for handling the FastAPI application setup and routes.

This module initializes the FastAPI application, sets up authentication
middleware, and defines routes for handling Nexus and Harbor events as well as
serving Prometheus metrics.

Routes:
    /repository: Handles events when a component is uploaded, updated, or
        removed in a Nexus repository.
    /harbor: Handles events when the scan of an OCI image is completed in
        Harbor.
    /metrics: Serves Prometheus metrics collected from Celery tasks.

Functions:
    validation_exception_handler: Custom handler for request validation errors.
    nexus_event: Endpoint to handle Nexus repository events.
    harbor_event: Endpoint to handle Harbor scan completion events.
    metrics: Endpoint to serve Prometheus metrics.
"""

import os

import yaml
from fastapi import FastAPI, Request, status
from fastapi.exceptions import RequestValidationError
from fastapi.responses import JSONResponse, Response
from prometheus_client import CONTENT_TYPE_LATEST
from starlette.middleware.sessions import SessionMiddleware

from ska_cicd_artefact_validations.api.authentication import (
    FactoryAuthenticator,
)
from ska_cicd_artefact_validations.api.hook_validation import HookValidator
from ska_cicd_artefact_validations.celeryconfig import (
    feature_toggler,
    initialize_feature_toggler,
)
from ska_cicd_artefact_validations.core.logging import logging
from ska_cicd_artefact_validations.metrics.metrics_manager import (
    metrics as metrics_manager,
)
from ska_cicd_artefact_validations.tasks.main_task import main_task

initialize_feature_toggler(feature_toggler)

app = FastAPI()

# OpenID/Oauth2.0 Middleware
app.add_middleware(
    SessionMiddleware,
    secret_key=os.environ["OPENID_SECRET"],
)

CONFIG_FILE = os.path.join(os.path.dirname(__file__), "api/auth_config.yaml")

with open(CONFIG_FILE, "r", encoding="utf-8") as f:
    auth_config = yaml.safe_load(f)


@app.exception_handler(RequestValidationError)
async def validation_exception_handler(
    request: Request, exc: RequestValidationError
):
    """
    Custom handler for request validation errors.

    This function logs the validation error details and returns a JSON response
    with a status code indicating the error.

    :param request: The incoming request that caused the validation error.
    :param exc: The validation error exception.
    :return: A JSON response containing the error details.
    """
    exc_str = f"{exc}".replace("\n", " ").replace("   ", " ")
    logging.error("%s: %s", request, exc_str)
    content = {"status_code": 422, "message": exc_str, "data": None}
    return JSONResponse(
        content=content, status_code=status.HTTP_422_UNPROCESSABLE_ENTITY
    )


@app.post("/nexus")
async def nexus_event(request: Request):
    """
    Handles events for components in a Nexus repository.

    This endpoint is triggered when a component is uploaded, updated, or
    removed in a Nexus repository. It authenticates the request and, if valid,
    triggers the main task for further processing.

    :param request: The incoming request object containing the event data.
    :return: A JSON response indicating the outcome of the request handling.
    """

    await FactoryAuthenticator(auth_config["nexus"]).authenticate(request)

    body = await request.json()

    if HookValidator("nexus").is_valid(body):
        main_task.delay(body, "nexus")
    else:
        logging.warning("Invalid Nexus request with body: %s", body)
        return JSONResponse(
            content={"message": "Rejected"},
            status_code=status.HTTP_400_BAD_REQUEST,
        )

    return JSONResponse(
        content={"message": "OK"}, status_code=status.HTTP_200_OK
    )


@app.post("/harbor")
async def harbor_event(request: Request):
    """
    Handles events for Harbor image scans.

    This endpoint is triggered when the scan of an OCI image is completed in
    Harbor. It authenticates the request and, if valid, triggers the main task
    for further processing.

    :param request: The incoming request object containing the event data.
    :return: A JSON response indicating the outcome of the request handling.
    """

    await FactoryAuthenticator(auth_config["harbor"]).authenticate(request)

    body = await request.json()

    if HookValidator("harbor").is_valid(body):
        main_task.delay(body, "harbor")
    else:
        logging.warning("Invalid Harbor request with body: %s", body)
        return JSONResponse(
            content={"message": "Rejected"},
            status_code=status.HTTP_400_BAD_REQUEST,
        )

    return JSONResponse(
        content={"message": "OK"}, status_code=status.HTTP_200_OK
    )


@app.get("/metrics")
async def metrics():
    """
    Serves Prometheus metrics collected from Celery tasks.

    This endpoint initializes a new CollectorRegistry, registers a
    MultiProcessCollector to the registry to collect metrics generated by
    different processes (Celery tasks), and serves the aggregated data in
    Prometheus format.

    :return: A response object containing the Prometheus-formatted metrics,
        with `media_type` set to the content type expected by Prometheus.
    """
    if feature_toggler.is_enabled(
        metrics_manager.feature_toggle,
        fallback_function=lambda feature_name, context: False,
    ):
        return Response(
            metrics_manager.get_metrics(), media_type=CONTENT_TYPE_LATEST
        )

    return JSONResponse(
        content={"message": "METRICS EXPORTER disabled"},
        status_code=status.HTTP_404_NOT_FOUND,
    )
